(* psDelegator.ml     Generic delegator to Wrappee.t
 *
 * Copyright (c) 2016 Psellos   http://psellos.com
 * Licensed under the MIT license:
 *     http://www.opensource.org/licenses/mit-license.php
 *)

(* An object of type PsDelegator.t is a wrapper for any ObjC object that
 * delegates to an OCaml object. It makes Gamut a little simpler by
 * avoiding unnecessary type specifications.
 *)

external _delegate : nativeint -> Wrappee.t =
    "PSDelegator_delegate"
external _setDelegate_ : nativeint -> Wrappee.t -> unit =
    "PSDelegator_setDelegate_"

class t robjcv =
object (self)
    inherit Wrapper.t robjcv
    method delegate = _delegate self#contents
    method setDelegate' d = _setDelegate_ self#contents d
end
